"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _gulp = _interopRequireDefault(require("gulp"));

var _gulpReplace = _interopRequireDefault(require("gulp-replace"));

var _del = _interopRequireDefault(require("del"));

var _lodash = require("lodash");

var _gulpBabel = _interopRequireDefault(require("gulp-babel"));

var _commander = _interopRequireDefault(require("commander"));

var _fs = _interopRequireDefault(require("fs"));

var _gulpTypescript = _interopRequireDefault(require("gulp-typescript"));

var _mapPaths = _interopRequireDefault(require("./mapPaths"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var digest = function digest(_ref) {
  var lernaConfig = _ref.lernaConfig,
      replaceFind = _ref.replaceFind,
      replaceStr = _ref.replaceStr,
      tsFilter = _ref.tsFilter,
      tsConfig = _ref.tsConfig;
  var tsconfig = tsConfig.compilerOptions;

  _commander["default"].version(lernaConfig.version).option('-p, --package <p>', 'package to use gulp against').parse(process.argv);

  var packages = _fs["default"].readdirSync('packages');

  if (_commander["default"]["package"]) {
    packages = [_commander["default"]["package"]];
  }
  /*
  Goal is to produce webpack consumable js in which portions of the library
  can be consumed without everything.
  Rollup is nice, but it usually puts the whole lib together without making the
  sections of lib optional.
  */


  var dists = {};
  packages.forEach(function (p) {
    dists[p] = "packages/".concat(p, "/lib");
  });

  _gulp["default"].task('clean', function () {
    return (0, _del["default"])(Object.values(dists));
  });

  var build = function build(pack) {
    var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        _ref2$transform = _ref2.transform,
        transform = _ref2$transform === void 0 ? function () {
      return (0, _gulpBabel["default"])();
    } : _ref2$transform,
        _ref2$exts = _ref2.exts,
        exts = _ref2$exts === void 0 ? ['js', 'ts', 'tsx'] : _ref2$exts;

    return function () {
      var src = (0, _mapPaths["default"])((0, _lodash.flattenDeep)(exts.map(function (ext) {
        return ["src/**/*.".concat(ext), "!src/**/*.spec*.".concat(ext), "!src/**/*.story*.".concat(ext)];
      })), pack);
      var dest = dists[pack];
      return _gulp["default"].src(src).pipe((0, _gulpReplace["default"])(replaceFind, replaceStr)).pipe(transform()).pipe(_gulp["default"].dest(dest));
    };
  }; // allows types to also piggy back extra `src`


  var types = function types(pack) {
    var _ref3 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        _ref3$src = _ref3.src,
        _src = _ref3$src === void 0 ? [] : _ref3$src;

    return function () {
      var src = (0, _mapPaths["default"])(['src/**/*.d.ts'].concat(_src), pack);
      var dest = dists[pack];
      return _gulp["default"].src(src).pipe((0, _gulpReplace["default"])(replaceFind, replaceStr)).pipe(_gulp["default"].dest(dest));
    };
  };

  var typescript = function typescript(pack, opts) {
    return build(pack, {
      transform: function transform() {
        return (0, _gulpTypescript["default"])(_objectSpread({}, tsconfig));
      },
      exts: (0, _lodash.get)(opts, ['ext'], tsFilter)
    });
  };

  return {
    babel: build,
    types: types,
    packages: packages,
    typescript: typescript
  };
};

var _default = digest;
exports["default"] = _default;